//
//  FailedBanksEditViewController.m
//  FailedBanks
//
//  Created by timoshiu on 7/13/12.
//  Copyright (c) 2012 Shiu. All rights reserved.
//

#import "FailedBanksEditViewController.h"
#import "FailedBanksInfo.h"
#import "FailedBanksCoreData.h"
#import "FailedBanksDatabase.h"
#import "FailedBanksViewController.h"
#import "FailedBanksInfoViewController.h"

@interface FailedBanksEditViewController () <UITextFieldDelegate>

@property (nonatomic,strong) FailedBanksCoreData* data;
@property (nonatomic,strong) NSArray* labels;

@end

@implementation FailedBanksEditViewController

@synthesize coredata = _coredata;
@synthesize database = _database;
@synthesize fetcher = _fetcher;
@synthesize edit = _edit;
@synthesize context = _context;
@synthesize data = _data;
@synthesize info = _info;
@synthesize labels = _labels;

- (NSArray*) labels 
{
    if (_labels != nil) { return _labels; }
    
    _labels = [NSArray arrayWithObjects:@"ID:", @"Name:", @"City:", @"State:", nil];
    return _labels;
}

- (UITextField*) makeTextField
{
    CGRect frame = CGRectMake(110, 10, 185, 30);
    UITextField *text = [[UITextField alloc] initWithFrame:frame];
    text.adjustsFontSizeToFitWidth = YES;
    text.textColor = [UIColor blackColor];
    text.placeholder = @"Detail";
    text.keyboardType = UIKeyboardTypeDefault;
    text.returnKeyType = UIReturnKeyDone;
    text.secureTextEntry = NO;
    text.autocorrectionType = UITextAutocorrectionTypeNo; 
    text.autocapitalizationType = UITextAutocapitalizationTypeNone; 
    text.textAlignment = UITextAlignmentRight;
    text.tag = 0;
    text.delegate = self;
    text.clearButtonMode = UITextFieldViewModeNever;
    text.enabled = YES;
    return text;
}

- (FailedBanksCoreData*) data
{
    if (_data != nil) { return _data; }
    _data = [[FailedBanksCoreData alloc] init];
    return _data;
}

- (FailedBanksInfo*) info
{
    if (_info != nil) { return _info; }
    _info = [[FailedBanksInfo alloc] init];
    return _info;
}

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void) setup
{
    self.navigationItem.title = @"Editing";
}

- (void) awakeFromNib
{
    [self setup];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self setup];
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)viewDidUnload
{
    [self setEdit:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void) updateInfo:(id)sender
{
    FailedBanksDatabase* database = self.database;
    FailedBanksInfo * info = self.info;
    [database updateInfo:info];

    UINavigationController* nav = [self navigationController];
    [nav popViewControllerAnimated:NO];
    FailedBanksInfoViewController* brief = (FailedBanksInfoViewController*) [nav popViewControllerAnimated:NO];
    brief.info = info;
    [brief reload];
    UIViewController* ctrl = [nav topViewController];
    [nav pushViewController:brief animated:NO];
    FailedBanksViewController* tbl = (FailedBanksViewController*) ctrl;
    [tbl reload];    
}

- (void) insertInfo:(id)sender
{
    FailedBanksDatabase* database = self.database;
    FailedBanksInfo * info = self.info;
    [database insertInfo:info];
    
    UINavigationController* nav = [self navigationController];
    [nav popViewControllerAnimated:YES];
    UIViewController* ctrl = [nav topViewController];
    FailedBanksViewController* tbl = (FailedBanksViewController*) ctrl;
    [tbl reload];    
}

- (void) insertInfo
{
    FailedBanksInfo* info = self.info;
   // [FailedBanksDatabase insertInfo:info];
    

    return;
    
    UITableViewCell* cell = nil;
    UITableView* tableView = self.tableView;
    cell = [tableView cellForRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0]];
    info.ident = [NSNumber numberWithInt:[cell.detailTextLabel.text intValue]];
    cell = [tableView cellForRowAtIndexPath:[NSIndexPath indexPathForRow:1 inSection:0]];
    info.bankName = cell.detailTextLabel.text;
    cell = [tableView cellForRowAtIndexPath:[NSIndexPath indexPathForRow:2 inSection:0]];
    info.city = cell.detailTextLabel.text;
    cell = [tableView cellForRowAtIndexPath:[NSIndexPath indexPathForRow:3 inSection:0]];
    info.state = cell.detailTextLabel.text;
}

- (void) saveData
{
    // FailedBanksCoreData* data = self.data;        
    // [self.context save:nil];
}

- (IBAction) inserthello:(id) sender
{
    UIBarButtonItem * button = (UIBarButtonItem*) sender;
    NSString* title = button.title;
    if ([title isEqualToString:@"insert"]) {
        // [self.info ];
        [self insertInfo];
    } else if ([title isEqualToString:@"update"]) {
        // [self updateInfo];
    }
}

#pragma mark - Table view data source

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [self.labels count];
}

- (void) fillTextFieldData:(UITextField*) field atIndexPath:(NSIndexPath *) indexPath
{
    FailedBanksCoreData* data = self.data;
    field.placeholder = @"detail";
    NSInteger row = indexPath.row;
    field.tag = row;
    switch (row) {
        case 0: field.text = [data.ident stringValue]; break;
        case 1: field.text = data.bankName; break;
        case 2: field.text = data.city; break;
        case 3: field.text = data.state; break;
        default: break;
    }
}

- (void) fillTextFieldInfo:(UITextField*) field atIndexPath:(NSIndexPath *) indexPath
{
    FailedBanksInfo* info = self.info;
    field.placeholder = @"detail";
    NSInteger row = indexPath.row;
    field.tag = row;
    switch (row) {
        case 0: field.text = [info.ident stringValue]; break;
        case 1: field.text = info.bankName; break;
        case 2: field.text = info.city; break;
        case 3: field.text = info.state; break;
        default: break;
    }
}

- (void ) saveTextFieldInfo:(UITextField*) field 
{
    NSInteger tag = field.tag;
    // FailedBanksCoreData* data = self.data;
    FailedBanksInfo *info = self.info;
    switch (tag) {
        case 0: info.ident = [NSNumber numberWithInt:[field.text intValue]]; break;
        case 1: info.bankName = field.text; break;
        case 2: info.city = field.text; break;
        case 3: info.state = field.text; break;
        default: break;
    }
}

- (BOOL)textFieldShouldReturn:(UITextField *)field {
    [field resignFirstResponder];    
    return YES;
}

- (UITableViewCell *)tableView:(UITableView *)tableView 
         cellForRowAtIndexPath:(NSIndexPath *)indexPath 
{    
    NSString* cellID = @"BankEditTableCell";
    UITableViewCell *cell = [self.tableView dequeueReusableCellWithIdentifier:cellID];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleValue1
                                      reuseIdentifier:cellID];
        cell.accessoryType = UITableViewCellAccessoryNone;
        NSInteger row = indexPath.row;
        NSString* label = [self.labels objectAtIndex:row];
        cell.textLabel.text = label;
        UITextField* field = [self makeTextField];
        cell.detailTextLabel.text = field.text;
        [cell.contentView addSubview:field];
        
        [self fillTextFieldInfo:field atIndexPath:indexPath];
        [field addTarget:self action:@selector(saveTextFieldInfo:) 
                    forControlEvents:UIControlEventEditingDidEnd];
    }
    return cell;    
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyles) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate


@end
