//
//  FailedBanksInfoViewController.m
//  FailedBanks
//
//  Created by timoshiu on 6/29/12.
//  Copyright (c) 2012 Shiu. All rights reserved.
//

#import "FailedBanksInfoViewController.h"
#import "FailedBanksEditViewController.h"


@implementation FailedBanksInfoViewController

@synthesize coredata = _coredata;
@synthesize database = _database;
@synthesize info = _info;

- (void) setup
{
    self.navigationItem.title = @"Information";
}

- (void) awakeFromNib
{
    [self setup];
}

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self setup];
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [self.info.array count];
}

- (void) identCell:(UITableViewCell*) cell
{
    cell.textLabel.text = @"ID:";
    NSString *ID = [NSString stringWithFormat:@"%@", self.info.ident];
    cell.detailTextLabel.text = ID;
}

- (void) nameCell:(UITableViewCell*) cell
{
    cell.textLabel.text = @"Name:";
    cell.detailTextLabel.text = self.info.bankName;
}

- (void) cityCell:(UITableViewCell*) cell
{
    cell.textLabel.text = @"City:";
    cell.detailTextLabel.text = self.info.city;
}

- (void) stateCell:(UITableViewCell*) cell
{
    cell.textLabel.text = @"State:";
    cell.detailTextLabel.text = self.info.state;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellID = @"BankInfoTableCell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellID];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellID];
    }
    // Configure the cell...
    NSInteger ith = indexPath.row;
    switch (ith) {
        case 0: [self identCell:cell]; break;
        case 1: [self nameCell:cell]; break;
        case 2: [self cityCell:cell]; break;
        case 3: [self stateCell:cell]; break;
 // case 4: cell.textLabel.text = nil; break;
 // case 5: cell.textLabel.text = nil; break;
        default: break; // error...
    }
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
}

- (void) prepareForSegueOfInfo2Edit:(UIStoryboardSegue *)segue sender:(id)sender
{
    NSLog(@"segue from edit to info");
    FailedBanksEditViewController* target = nil;
    target = segue.destinationViewController;
    FailedBanksInfo* info = self.info;
    target.info = [[FailedBanksInfo alloc] initWithId:[info.ident intValue] named:info.bankName city:info.city state:info.state];
    [target.edit setTarget:target];
    [target.edit setTitle:@"update"];
    [target.edit setAction:@selector(updateInfo:)];
    target.database = self.database;
    // target.coredata = self.coredata;
    
}

- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    NSString* ident = segue.identifier;
    if ([ident isEqualToString:@"Info2Edit"]) {
        [self prepareForSegueOfInfo2Edit:segue sender:sender];
    }
}

- (void) reload
{
    [self.tableView reloadData];
}

@end
