#!/usr/bin/env ruby

require 'sqlite3'
require 'CSV'

def get_sqlite3(table)
  "make the sqlite3 from the create table statement"
  db = SQLite3::Database.new("#{table}.sqlite3")
  fields = ["Ident integer primary key",
    "Bank_Name text",
    "City text",
    "State text",
    "Certicate_Id integer",
    "Acquiring_Institution text",
    "Closing_Date text",
    "Updated_Date text"]
  columns = fields.join(", ")
  db.execute("create table #{table} (#{columns})")
  db
end

def get_csv(table)
  "get the csv file into an array"
  rows = CSV.read("#{table}.csv")
  rows.shift # skip the header line in the .csv file
  rows
end

def fill_table(table)
  "fill the sqlite3 table from the given csv file name"
  db = get_sqlite3 table
  rows = get_csv table

  fields = ["Ident", 
    "Bank_Name",
    "City",
    "State",
    "Certicate_Id",
    "Acquiring_Institution",
    "Closing_Date",
    "Updated_Date"]
  columns = fields.join(", ")

  rows.each_with_index do |row, index|
    fields = ["#{index}",
      "\"#{row[0]}\"", 
      "\"#{row[1]}\"", 
      "\"#{row[2]}\"", 
      "#{row[3]}", 
      "\"#{row[4]}\"", 
      "'#{row[5]}'", 
      "'#{row[6]}'"]
    data = fields.join(", ")
    stmt = "INSERT INTO #{table} (#{columns}) values (#{data})"
    db.execute(stmt)
  end

end

fill_table "banklist"

